VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Google Maps API Signature Generator"
   ClientHeight    =   3045
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   10050
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3045
   ScaleWidth      =   10050
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   495
      Left            =   8700
      TabIndex        =   3
      Top             =   1440
      Width           =   1215
   End
   Begin VB.TextBox txtSignedURL 
      BackColor       =   &H8000000F&
      ForeColor       =   &H80000012&
      Height          =   735
      Left            =   2760
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   2160
      Width           =   7215
   End
   Begin VB.CommandButton cmdGenerate 
      Caption         =   "Generate"
      Height          =   495
      Left            =   2760
      TabIndex        =   2
      Top             =   1440
      Width           =   1215
   End
   Begin VB.TextBox txtPKMB64 
      Height          =   375
      Left            =   2760
      TabIndex        =   1
      Text            =   "vNIXE0xscrmjlyV-12Nj_BvUPaw="
      Top             =   960
      Width           =   3495
   End
   Begin VB.TextBox txtUrl 
      Height          =   735
      Left            =   2760
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   120
      Width           =   7215
   End
   Begin VB.Label Label5 
      Alignment       =   1  'Right Justify
      Caption         =   "Full Signed URL"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2220
      Width           =   2595
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Private Key (modified Base64)"
      Height          =   255
      Left            =   60
      TabIndex        =   5
      Top             =   1020
      Width           =   2595
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "URL"
      Height          =   255
      Left            =   60
      TabIndex        =   4
      Top             =   180
      Width           =   2595
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Example showing how to generate a Google Maps API Signature.
'
'The code here is verbose with named intermediate results
'to help illustrate the process.

Private Sub EnableGenerate()
    cmdGenerate.Enabled = Len(txtUrl.Text) > 0 And Len(txtPKMB64.Text) > 0
End Sub

Private Sub cmdGenerate_Click()
    Dim Url As String
    Dim GMS As GoogleMapsSigner
    
    'Note: Since we're taking this from a multiline TextBox we'll
    'have to zap any extraneous newlines.  This is not part of
    'the signature algorithm as such.
    Url = Replace$(Trim$(txtUrl.Text), vbNewLine, vbNullString)
    
    Set GMS = New GoogleMapsSigner
    On Error Resume Next
    txtSignedURL.Text = GMS.Sign(Url, Trim$(txtPKMB64.Text))
    If Err Then
        MsgBox "Error " & CStr(Err.Number) & " in " & Err.Source & vbNewLine & vbNewLine _
             & Err.Description
        txtUrl.SetFocus
    Else
        cmdReset.SetFocus
    End If
End Sub

Private Sub cmdReset_Click()
    txtUrl.Text = vbNullString
    txtPKMB64.Text = vbNullString
    txtSignedURL.Text = vbNullString
    
    txtUrl.SetFocus
End Sub

Private Sub Form_Load()
    EnableGenerate
End Sub

Private Sub txtPKMB64_Change()
    EnableGenerate
End Sub

Private Sub txtUrl_Change()
    EnableGenerate
End Sub
